\name{D2K}
\alias{D2K}
\title{construct kernel matrix from distance metric}
\description{
  Construct kernel matrix from distance metric from microbiome data.  
}

\usage{  
D2K(D)}
\arguments{
    \item{D}{A n by n matrix giving the distance metric between the microbiome compositions (n is the sample size).}
}
\details{
The kernel matrix is constructed as \eqn{K = - (I - 11'/n)D^2 (I - 11'/n)/2}, where D is the pairwise distance matrix, I is an identity matrix and 1 is a vector of 1. \eqn{D^2} represents element wise square. To ensure that \eqn{K} to be positive semi-definite, a positive semi-definiteness correction is conducted.  

}

\value{
  K: A kernel matrix corresponding to the distance metix }

\author{Ni Zhao}

\examples{  
  #############################################################
 # Load in data and create a distance metric
 data(throat.tree)
 data(throat.otu.tab)
 unifracs = GUniFrac(throat.otu.tab, throat.tree, alpha = c(1))$unifracs
 D1 = unifracs[,,"d_1"]
 # Function
 K = D2K(D1)
 
}

